package com.jiuqi.util.patterns;

import java.util.Map;

public class Patterns
{
    PlaceholderPattern root;
    
    public static Patterns getInstance() {
        return new Patterns();
    }
    
    protected Patterns() {
        this.root = new PlaceholderPattern();
    }
    
    public void parse(final String patternStr) throws PatternException {
        this.root.parse(patternStr);
    }
    
    public boolean match(final String s, final Map values) {
        if (s == null) {
            return false;
        }
        final int p = this.root.match(s, 0, values);
        return p != -1 && p == s.length();
    }
    
    public String repace(final ITranslator translator) {
        return this.root.replace(translator);
    }
    
    protected IPattern getRoot() {
        return this.root;
    }
    
    @Override
    public String toString() {
        if (this.root.size() == 0) {
            return "(null)";
        }
        return this.root.toString();
    }
}
